﻿  --get the addon namespace
  local addon, ns = ...
  --get the config values
  local cfg = ns.cfg
  local dragFrameList = ns.dragFrameList

------------------------
-- HIDING PARTS OF UI --
------------------------
  
	local event_frame = CreateFrame('Frame')
	local errormessage_blocks = {
	  'Ability is not ready yet',
 	  'Another action is in progress',
	  'Can\'t attack while mounted',
	  'Can\'t do that while moving',
	  'Item is not ready yet',
	  'Not enough',
	  'Nothing to attack',
	  'Spell is not ready yet',
	  'You have no target',
	  'You can\'t do that yet',
	}
	local enable
	local onevent
	local uierrorsframe_addmessage
	local old_uierrosframe_addmessage
	function enable ()
  		old_uierrosframe_addmessage = UIErrorsFrame.AddMessage
  		UIErrorsFrame.AddMessage = uierrorsframe_addmessage
	end

	function uierrorsframe_addmessage (frame, text, red, green, blue, id)
  		for i,v in ipairs(errormessage_blocks) do
    			if text and text:match(v) then
      				return
    			end
  		end
  		old_uierrosframe_addmessage(frame, text, red, green, blue, id)
	end

	function onevent (frame, event, ...)
  		if event == 'PLAYER_LOGIN' then
    			enable()
  		end
	end
	event_frame:SetScript('OnEvent', onevent)
	event_frame:RegisterEvent('PLAYER_LOGIN')
	

-------------
-- MINIMAP --
-------------

	local CF=CreateFrame("Frame")
	CF:RegisterEvent("PLAYER_LOGIN")
	CF:SetScript("OnEvent", function(self, event)
		if not (IsAddOnLoaded("SexyMap")) then
			for i,v in pairs({
				MinimapBorder,
				MiniMapMailBorder,
				QueueStatusMinimapButtonBorder,
				select(1, TimeManagerClockButton:GetRegions()),
              		}) do
                 		v:SetVertexColor(0, 0, 0)
			end
			select(2, TimeManagerClockButton:GetRegions()):SetVertexColor(1,1,1)

			hooksecurefunc("GarrisonLandingPageMinimapButton_UpdateIcon", function(self)
				self:GetNormalTexture():SetTexture(nil)
				self:GetPushedTexture():SetTexture(nil)
				if not gb then
					gb = CreateFrame("Frame", nil, GarrisonLandingPageMinimapButton)
					gb:SetFrameLevel(GarrisonLandingPageMinimapButton:GetFrameLevel() - 1)
					gb:SetPoint("CENTER", 0, 0)
					gb:SetSize(36,36)

					gb.icon = gb:CreateTexture(nil, "ARTWORK")
					gb.icon:SetPoint("CENTER", 0, 0)
					gb.icon:SetSize(36,36)
			
					gb.border = CreateFrame("Frame", nil, gb)
					gb.border:SetFrameLevel(gb:GetFrameLevel() + 1)
					gb.border:SetAllPoints()

					gb.border.texture = gb.border:CreateTexture(nil, "ARTWORK")
					gb.border.texture:SetTexture("Interface\\PlayerFrame\\UI-PlayerFrame-Deathknight-Ring")
					gb.border.texture:SetVertexColor(0, 0, 0)
					gb.border.texture:SetPoint("CENTER", 1, -2)
					gb.border.texture:SetSize(45,45)
				end
				if (C_Garrison.GetLandingPageGarrisonType() == 2) then
					if select(1,UnitFactionGroup("player")) == "Alliance" then	
						SetPortraitToTexture(gb.icon, select(3,GetSpellInfo(61573)))
					elseif select(1,UnitFactionGroup("player")) == "Horde" then
						SetPortraitToTexture(gb.icon, select(3,GetSpellInfo(61574)))
					end
				else
					local t = CLASS_ICON_TCOORDS[select(2,UnitClass("player"))]
                			gb.icon:SetTexture("Interface\\TargetingFrame\\UI-Classes-Circles")
                			gb.icon:SetTexCoord(unpack(t))
				end
			end)
		
  			MinimapBorderTop:Hide()
			MinimapZoomIn:Hide()
			MinimapZoomOut:Hide()
			MiniMapWorldMapButton:Hide()
			MinimapZoneText:SetPoint("CENTER", Minimap, 0, 80)
			GameTimeFrame:Hide()
			GameTimeFrame:UnregisterAllEvents()
			GameTimeFrame.Show = kill
			MiniMapTracking:Hide()
			MiniMapTracking.Show = kill
			MiniMapTracking:UnregisterAllEvents()
			Minimap:EnableMouseWheel(true)
			Minimap:SetScript("OnMouseWheel", function(self, z)
				local c = Minimap:GetZoom()
				if(z > 0 and c < 5) then
					Minimap:SetZoom(c + 1)
				elseif(z < 0 and c > 0) then
					Minimap:SetZoom(c - 1)
				end
			end)
			Minimap:SetScript("OnMouseUp", function(self, btn)
				if btn == "RightButton" then
					_G.GameTimeFrame:Click()
				elseif btn == "MiddleButton" then
					_G.ToggleDropDownMenu(1, nil, _G.MiniMapTrackingDropDown, self)
				else
					_G.Minimap_OnClick(self)
				end
			end)
		end
	end)


---------------------
-- COLORING FRAMES --
---------------------

	local frame = CreateFrame("Frame")
	frame:RegisterEvent("ADDON_LOADED")

	frame:SetScript("OnEvent", function(self, event, addon)
        	if (addon == "MattDF") then
               		for i, v in pairs({ 
				ActionBarFrameTexture, 
				PlayerFrameTexture,
				TargetFrameTextureFrameTexture,
				PlayerFrameAlternateManaBarBorder,
				PlayerFrameAlternateManaBarLeftBorder,
				PlayerFrameAlternateManaBarRightBorder,
				ComboPointPlayerFrame.Background,
				ComboPointPlayerFrame.Combo1.PointOff,
				ComboPointPlayerFrame.Combo2.PointOff,
				ComboPointPlayerFrame.Combo3.PointOff,
				ComboPointPlayerFrame.Combo4.PointOff,
				ComboPointPlayerFrame.Combo5.PointOff,
				ComboPointPlayerFrame.Combo6.PointOff,
				AlternatePowerBarBorder,
				AlternatePowerBarLeftBorder,
				AlternatePowerBarRightBorder,
  				PetFrameTexture,
				PartyMemberFrame1Texture,
				PartyMemberFrame2Texture,
				PartyMemberFrame3Texture,
				PartyMemberFrame4Texture,
				PartyMemberFrame1PetFrameTexture,
				PartyMemberFrame2PetFrameTexture,
				PartyMemberFrame3PetFrameTexture,
				PartyMemberFrame4PetFrameTexture,
   				FocusFrameTextureFrameTexture,
   				TargetFrameToTTextureFrameTexture,
   				FocusFrameToTTextureFrameTexture,
				Boss1TargetFrameTextureFrameTexture,
				Boss2TargetFrameTextureFrameTexture,
				Boss3TargetFrameTextureFrameTexture,
				Boss4TargetFrameTextureFrameTexture,
				Boss5TargetFrameTextureFrameTexture,
				Boss1TargetFrameSpellBarBorder,
				Boss2TargetFrameSpellBarBorder,
				Boss3TargetFrameSpellBarBorder,
				Boss4TargetFrameSpellBarBorder,
				Boss5TargetFrameSpellBarBorder,
				CastingBarFrameBorder,
				FocusFrameSpellBarBorder,
				TargetFrameSpellBarBorder
                	}) do
                        	v:SetVertexColor(0, 0, 0)
                	end

			for _, region in pairs({CompactRaidFrameManager:GetRegions()}) do
				if region:IsObjectType("Texture") then
					region:SetVertexColor(0, 0, 0)
				end
			end

			for _, region in pairs({CompactRaidFrameManagerContainerResizeFrame:GetRegions()}) do
				if region:GetName():find("Border") then
					region:SetVertexColor(0, 0, 0)
				end
			end

			CompactRaidFrameManagerToggleButton:SetNormalTexture("Interface\\AddOns\\MattDF\\textures\\RaidPanel-Toggle")

                	self:UnregisterEvent("ADDON_LOADED")
                	frame:SetScript("OnEvent", nil)
        	end
	end)